VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cReturnNote"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3F0E8B6B038D"

'<CAMH>****************************************************************************************
'* Module: cReturnNote
'* Date  : 02/12/02
'* Author: mauricem
'*$Archive: /Projects/OasysV2/VB/ReturnsBO/cReturnNote.cls $
'**********************************************************************************************
'* Summary: Business Object to wrap the functionality of a single Delivery Note
'**********************************************************************************************
'* $Author: Mauricem $ $Date: 11/05/04 19:13 $ $Revision: 12 $
'* Versions:
'* 15/08/02    mauricem
'*             Header added.
'</CAMH>***************************************************************************************
Option Base 0
Option Explicit

'##ModelId=3F0E8B6C0014
Const MODULE_NAME As String = "cReturnNote"

'##ModelId=3F0E8B6C0059
Const DOCTYPE_SUPPRET As String = "3"
'##ModelId=3F0E8B6C00AA
Const RET_NOTE_FILECODE As String = "RC"
Const SHORTAGES_DOC_CODE As String = "S"

Implements IBo
Implements ISysBo

'##ModelId=3F0E8B6C00DC
Private m_oSession As Session

'##ModelId=3F0E8B6C0104
Private mDocNo As String

'##ModelId=3F0E8B6C0136
Private mDocType As String

'##ModelId=3F0E8B6C0168
Private mValue As Currency

'##ModelId=3F0E8B6C019A
Private mCost As Double

'##ModelId=3F0E8B6C01CC
Private mDelNoteDate As Date

'##ModelId=3F0E8B6C01FE
Private mComm As String

'##ModelId=3F0E8B6C0230
Private mOrigDocKey As Long

'##ModelId=3F0E8B6C0262
Private mEnteredBy As String

'##ModelId=3F0E8B6C029E
Private mComment As String

'##ModelId=3F0E8B6C02D0
Private mConsignmentRef As String

'##ModelId=3F0E8B6C0302
Private mPONumber As String

'##ModelId=3F0E8B6C033F
Private mPODate As Date

'##ModelId=3F0E8B6C037B
Private mReleaseNumber As String

'##ModelId=3F0E8B6C03B7
Private mSOQControlNumber As String

'##ModelId=3F0E8B6D000B
Private mStoreNo As String

'##ModelId=3F0E8B6D0047
Private mPrinted As Boolean

'##ModelId=3F0E8B6D0083
Private mConsignmentKey As String

'##ModelId=3F0E8B6D00C9
Private mSupplierNumber As String

'##ModelId=3F0E8B6D010F
Private mReturnDate As Date

'##ModelId=3F0E8B6D014B
Private mOrigPONumber As String

'##ModelId=3F0E8B6D0191
Private mSupplierReturnNumber As String

'##ModelId=3F0E8B6D01D7
Private mInvCrnMatched As String

'##ModelId=3F0E8B6D021E
Private mInvCrnDate As Date

'##ModelId=3F0E8B6D0264
Private mInvCrnNumber As String

'##ModelId=3F0E8B6D02AA
Private mVarianceValue As Currency

'##ModelId=3F0E8B6D02FA
Private mInvoiceValue As Currency

'##ModelId=3F0E8B6D0340
Private mInvoiceVAT As Currency

'##ModelId=3F0E8B6D0386
Private mMatchingComment As String

'##ModelId=3F0E8B6D03D6
Private mCollectionNoteNumber As String

'##ModelId=3F0E8B6E0034
Private mMatchingDate As Date

'##ModelId=3F0E8B6E0084
Private mReceiptDate As Date

'##ModelId=3F0E8B6E00D5
Private mRestockCharge As Currency

'##ModelId=3F0E8B6E0125
Private mCommit As String

'##ModelId=3F0E8B6E0175
Private mNarrative As String

'##ModelId=3F0E8B6E01C5
Private mSource As String

'##ModelId=3F0E8B6E0215
Private mOriginalDelNoteDRL As String

Private mShortageNote As Boolean

'##ModelId=3F0E8B6E0265
Private mGetLines As Boolean

'##ModelId=3F0E8B6E02BF
Private mcolLines As Collection

'##ModelId=3F0E8B6E030F
Private moRowSel As IRowSelector

'##ModelId=3F0E8B6E0369
Private moLoadRow As IRowSelector

'##ModelId=3F0E8B6E03BA
Private mintNarrStatus As Integer 'flag if narrative edited - -1 (Not Loaded), 0=Okay and 1 = Edited

'##ModelId=3F0E8B6F002C
Private mastrUpdatedLines() As String

Private mDelNote As cDeliveryNote 'provide reference to Delivery Note for updating Shortages/Returns if set

'##ModelId=3F0E8B6F0086
Const NOT_LOADED As Long = -1
'##ModelId=3F0E8B6F00E0
Const LOADED As Long = 0
'##ModelId=3F0E8B6F0144
Const EDITED As Long = 1

'##ModelId=3F0E8B6F01A8
Public Property Let GetLines(ByVal Value As Boolean)
   Let mGetLines = Value
End Property
'##ModelId=3F0E8B6F025D
Public Property Get Lines() As Collection
    
    If (mcolLines Is Nothing) And (mGetLines = True) Then Call RetrieveLines
    If mcolLines Is Nothing Then Set mcolLines = New Collection
    Set Lines = mcolLines

End Property

Public Property Set DelNote(ByVal Value As cDeliveryNote)

Dim lngLineNo As Long
   
    Set mDelNote = Value
    If (mcolLines Is Nothing) And (mGetLines = True) Then Call RetrieveLines
    If ((mcolLines Is Nothing) = False) Then
        For lngLineNo = 1 To mcolLines.Count Step 1
            Set mcolLines(CLng(lngLineNo)).DelNote = mDelNote
        Next lngLineNo
    End If

End Property

'##ModelId=3F0E8B6F02B7
Private Sub RetrieveLines()

Dim oLine     As cReturnNoteLine
Dim lngLineNo As Long

    'If Order found then get lines for Order
    Set mcolLines = New Collection
    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNNOTELINE)
    Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_RETURNNOTELINE_RetNoteKey, mDocNo)
    Set mcolLines = oLine.IBo_LoadMatches
    'Point line to reference Return Note Header
    For lngLineNo = 1 To mcolLines.Count Step 1
        Set mcolLines(CLng(lngLineNo)).ReturnNote = Me
        Set mcolLines(CLng(lngLineNo)).DelNote = mDelNote
    Next lngLineNo

End Sub
'<CACH>*************************************************************************
'* Sub:  Record Collected()
'******************************************************************************
'* Description: Business rule called by Maintain Supplier Return to record
'*              supplier has collected goods.
'* Parameters:
'*In:DocumentNumber  String. - Unique Document number used to load in Doc if not
'*                             already loaded
'*In:CollectionNoteNo   String. - Suppliers collection note number
'*In:CollectionDate   Date. - Date goods where collected
'******************************************************************************
'* History:
'* 15/01/03    mauricem
'*             Header added.
'</CACH>***********************************************************************
'##ModelId=3F0E8B6F02F3
Public Sub RecordCollected(ByVal DocumentNumber As String, ByVal CollectionNoteNo As String, ByVal CollectionDate As Date)

Dim oRow As IRow
            
    'Check if document has been loaded
    If mDocNo <> DocumentNumber Then
        Call IBo_AddLoadFilter(CMP_EQUAL, FID_RETURNNOTE_DocNo, DocumentNumber)
        
        Call IBo_AddLoadField(FID_RETURNNOTE_DocNo)
        Call IBo_AddLoadField(FID_RETURNNOTE_ReturnDate)
        Call IBo_AddLoadField(FID_RETURNNOTE_SupplierReturnNumber)
        
        Call IBo_Load
    End If
    
    'Update fields accordingly
    mReturnDate = CollectionDate
    mSupplierReturnNumber = CollectionNoteNo

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_RETURNNOTE_DocNo))
    Call oRow.Add(GetField(FID_RETURNNOTE_ReturnDate))
    Call oRow.Add(GetField(FID_RETURNNOTE_SupplierReturnNumber))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordCollected

'##ModelId=3F0E8B700037
Public Property Let Printed(ByVal Value As Boolean)
    Let mPrinted = Value
End Property

'##ModelId=3F0E8B7000EB
Public Property Get Printed() As Boolean
   Let Printed = mPrinted
End Property

Public Property Let ShortageNote(ByVal Value As Boolean)
    Let mShortageNote = Value
End Property

Public Property Get ShortageNote() As Boolean
   Let ShortageNote = mShortageNote
End Property

'##ModelId=3F0E8B700150
Public Property Let Narrative(ByVal Value As String)
    mNarrative = Value
    mintNarrStatus = EDITED
End Property

'##ModelId=3F0E8B700204
Public Property Get Narrative() As String

Dim oDRLNarr As Object

    If mintNarrStatus = NOT_LOADED Then
        Set oDRLNarr = m_oSession.Database.CreateBusinessObject(CLASSID_DELNOTENARRATIVE)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_DocumentNumber, mDocNo)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_StoreNumber, m_oSession.CurrentEnterprise.IEnterprise_StoreNumber)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_PartCode, "000000")
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_SequenceNumber, "0000")
        Call oDRLNarr.IBo_Load
        mNarrative = oDRLNarr.NarrativeText1
        If LenB(oDRLNarr.NarrativeText2) <> 0 Then mNarrative = mNarrative & vbCrLf & oDRLNarr.NarrativeText2
        Set oDRLNarr = Nothing
        mintNarrStatus = LOADED
    End If
    Narrative = mNarrative
    
End Property


'##ModelId=3F0E8B700268
Public Function AddItem(PartCode As String) As cReturnNoteLine

Dim oLine As cReturnNoteLine

    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNNOTELINE)
    Set oLine.ReturnNote = Me
    Set oLine.DelNote = mDelNote
    oLine.PartCode = PartCode
    
    If mcolLines Is Nothing Then Set mcolLines = New Collection
    Call mcolLines.Add(oLine)
    oLine.LineNo = mcolLines.Count
    Set AddItem = oLine

End Function

'##ModelId=3F0E8B7003B2
Public Property Get Commit() As String
   Let Commit = mCommit
End Property

'##ModelId=3F0E8B7002F4
Public Property Let Commit(ByVal Value As String)
    Let mCommit = Value
End Property

'##ModelId=3F0E8B7100ED
Public Property Get RestockCharge() As Currency
   Let RestockCharge = mRestockCharge
End Property

'##ModelId=3F0E8B71002F
Public Property Let RestockCharge(ByVal Value As Currency)
    Let mRestockCharge = Value
End Property

'##ModelId=3F0E8B71020F
Public Property Get ReceiptDate() As Date
   Let ReceiptDate = mReceiptDate
End Property

'##ModelId=3F0E8B710151
Public Property Let ReceiptDate(ByVal Value As Date)
    Let mReceiptDate = Value
End Property

'##ModelId=3F0E8B71033C
Public Property Get MatchingDate() As Date
   Let MatchingDate = mMatchingDate
End Property

'##ModelId=3F0E8B71027D
Public Property Let MatchingDate(ByVal Value As Date)
    Let mMatchingDate = Value
End Property

'##ModelId=3F0E8B720080
Public Property Get MatchingComment() As String
   Let MatchingComment = mMatchingComment
End Property

'##ModelId=3F0E8B7103AA
Public Property Let MatchingComment(ByVal Value As String)
    Let mMatchingComment = Value
End Property

'##ModelId=3F0E8B7201C1
Public Property Get InvoiceVAT() As Currency
   Let InvoiceVAT = mInvoiceVAT
End Property

'##ModelId=3F0E8B7200EE
Public Property Let InvoiceVAT(ByVal Value As Currency)
    Let mInvoiceVAT = Value
End Property

'##ModelId=3F0E8B7202F7
Public Property Get InvoiceValue() As Currency
   Let InvoiceValue = mInvoiceValue
End Property

'##ModelId=3F0E8B72022F
Public Property Let InvoiceValue(ByVal Value As Currency)
    Let mInvoiceValue = Value
End Property

'##ModelId=3F0E8B730050
Public Property Get VarianceValue() As Currency
   Let VarianceValue = mVarianceValue
End Property

'##ModelId=3F0E8B72036F
Public Property Let VarianceValue(ByVal Value As Currency)
    Let mVarianceValue = Value
End Property

'##ModelId=3F0E8B7301A4
Public Property Get InvCrnNumber() As String
   Let InvCrnNumber = mInvCrnNumber
End Property

'##ModelId=3F0E8B7300C8
Public Property Let InvCrnNumber(ByVal Value As String)
    Let mInvCrnNumber = Value
End Property

'##ModelId=3F0E8B7302F9
Public Property Get CollectionNoteNumber() As String
   Let CollectionNoteNumber = mCollectionNoteNumber
End Property

'##ModelId=3F0E8B73021C
Public Property Let CollectionNoteNumber(ByVal Value As String)
    Let mCollectionNoteNumber = Value
End Property

'##ModelId=3F0E8B740065
Public Property Get InvCrnDate() As Date
   Let InvCrnDate = mInvCrnDate
End Property

'##ModelId=3F0E8B730371
Public Property Let InvCrnDate(ByVal Value As Date)
    Let mInvCrnDate = Value
End Property

'##ModelId=3F0E8B7401C4
Public Property Get InvCrnMatched() As String
   Let InvCrnMatched = mInvCrnMatched
End Property

'##ModelId=3F0E8B7400E7
Public Property Let InvCrnMatched(ByVal Value As String)
    Let mInvCrnMatched = Value
End Property

'##ModelId=3F0E8B740322
Public Property Get SupplierReturnNumber() As String
   Let SupplierReturnNumber = mSupplierReturnNumber
End Property

'##ModelId=3F0E8B74023C
Public Property Let SupplierReturnNumber(ByVal Value As String)
    Let mSupplierReturnNumber = Value
End Property

'##ModelId=3F0E8B7500A3
Public Property Get OrigPONumber() As String
   Let OrigPONumber = mOrigPONumber
End Property

'##ModelId=3F0E8B74039A
Public Property Let OrigPONumber(ByVal Value As String)
    Let mOrigPONumber = Value
End Property

'##ModelId=3F0E8B75020B
Public Property Get ReturnDate() As Date
   Let ReturnDate = mReturnDate
End Property

'##ModelId=3F0E8B750125
Public Property Let ReturnDate(ByVal Value As Date)
    Let mReturnDate = Value
End Property

'##ModelId=3F0E8B750374
Public Property Get SupplierNumber() As String
   Let SupplierNumber = mSupplierNumber
End Property

'##ModelId=3F0E8B75028D
Public Property Let SupplierNumber(ByVal Value As String)
    Let mSupplierNumber = Value
    'Fudge to meet UpTrac Supplier Returns viewer
    mSupplierReturnNumber = Value
End Property

'##ModelId=3F0E8B760108
Public Property Get ConsignmentKey() As String
   Let ConsignmentKey = mConsignmentKey
End Property

'##ModelId=3F0E8B76000E
Public Property Let ConsignmentKey(ByVal Value As String)
    Let mConsignmentKey = Value
End Property

'##ModelId=3F0E8B76028F
Public Property Get StoreNo() As String
   Let StoreNo = mStoreNo
End Property

'##ModelId=3F0E8B760194
Public Property Let StoreNo(ByVal Value As String)
    Let mStoreNo = Value
End Property

'##ModelId=3F0E8B770037
Public Property Get SOQControlNumber() As String
   Let SOQControlNumber = mSOQControlNumber
End Property

'##ModelId=3F0E8B76031B
Public Property Let SOQControlNumber(ByVal Value As String)
    Let mSOQControlNumber = Value
End Property

'##ModelId=3F0E8B7701BE
Public Property Get ReleaseNumber() As String
   Let ReleaseNumber = mReleaseNumber
End Property

'##ModelId=3F0E8B7700C3
Public Property Let ReleaseNumber(ByVal Value As String)
    Let mReleaseNumber = Value
End Property

'##ModelId=3F0E8B77034E
Public Property Get PODate() As Date
   Let PODate = mPODate
End Property

'##ModelId=3F0E8B77024A
Public Property Let PODate(ByVal Value As Date)
    Let mPODate = Value
End Property

'##ModelId=3F0E8B7800F7
Public Property Get PONumber() As String
   Let PONumber = mPONumber
End Property

'##ModelId=3F0E8B7703DB
Public Property Let PONumber(ByVal Value As String)
    Let mPONumber = Value
End Property

'##ModelId=3F0E8B780292
Public Property Get ConsignmentRef() As String
   Let ConsignmentRef = mConsignmentRef
End Property

'##ModelId=3F0E8B78018D
Public Property Let ConsignmentRef(ByVal Value As String)
    Let mConsignmentRef = Value
End Property

'##ModelId=3F0E8B790044
Public Property Get Comment() As String
   Let Comment = mComment
End Property

'##ModelId=3F0E8B780328
Public Property Let Comment(ByVal Value As String)
    Let mComment = Value
End Property

'##ModelId=3F0E8B7901E9
Public Property Get OriginalDelNoteDRL() As String
   Let OriginalDelNoteDRL = mOriginalDelNoteDRL
End Property

'##ModelId=3F0E8B7900DA
Public Property Let OriginalDelNoteDRL(ByVal Value As String)
    Let mOriginalDelNoteDRL = Value
End Property

'##ModelId=3F0E8B7903A1
Public Property Get EnteredBy() As String
   Let EnteredBy = mEnteredBy
End Property

'##ModelId=3F0E8B790293
Public Property Let EnteredBy(ByVal Value As String)
    Let mEnteredBy = Value
End Property

'##ModelId=3F0E8B7A0172
Public Property Get OrigDocKey() As Long
   Let OrigDocKey = mOrigDocKey
End Property

'##ModelId=3F0E8B7A005A
Public Property Let OrigDocKey(ByVal Value As Long)
    Let mOrigDocKey = Value
End Property

'##ModelId=3F0E8B7A0208
Public Property Get Comm() As String
   Let Comm = mComm
End Property

'##ModelId=3F0E8B7A03B7
Public Property Get DelNoteDate() As Date
   Let DelNoteDate = mDelNoteDate
End Property

'##ModelId=3F0E8B7A029E
Public Property Let DelNoteDate(ByVal Value As Date)
    Let mDelNoteDate = Value
End Property

'##ModelId=3F0E8B7B0187
Public Property Get Cost() As Double
   Let Cost = mCost
End Property

'##ModelId=3F0E8B7B0065
Public Property Let Cost(ByVal Value As Double)
    Let mCost = Value
End Property

'##ModelId=3F0E8B7B0340
Public Property Get Value() As Currency
   Let Value = mValue
End Property

'##ModelId=3F0E8B7B0228
Public Property Let Value(ByVal Value As Currency)
    Let mValue = Value
End Property

'##ModelId=3F0E8B7B03E0
Public Property Get DocType() As String
   Let DocType = mDocType
End Property


'##ModelId=3F0E8B7C01C5
Public Property Get DocNo() As String
   Let DocNo = mDocNo
End Property


'##ModelId=3F0E8B7C0099
Public Property Let DocNo(ByVal Value As String)
    Let mDocNo = Value
End Property

'<CACH>*************************************************************************
'* Function:  Boolean LoadFromRow()
'******************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a
'*              row of field and for this object to extract the data and populate
'*              the properties of the object.
'******************************************************************************
'* Parameters:
'* In/Out:oRow   Object. - collection of fields
'******************************************************************************
'* Returns:  Boolean
'******************************************************************************
'* History:
'* 15/08/02    mauricem
'*             Header added.
'</CACH>***********************************************************************
'##ModelId=3F0E8B7C026F
Public Function LoadFromRow(oRow As IRow) As Boolean

Dim lFieldNo As Integer
Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".LoadFromRow"

    mintNarrStatus = NOT_LOADED
    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        Select Case (oField.ID)
            Case (FID_RETURNNOTE_DocNo):            mDocNo = oField.ValueAsVariant
            Case (FID_RETURNNOTE_DocType):          mDocType = oField.ValueAsVariant
            Case (FID_RETURNNOTE_Value):            mValue = oField.ValueAsVariant
            Case (FID_RETURNNOTE_Cost):             mCost = oField.ValueAsVariant
            Case (FID_RETURNNOTE_DelNoteDate):      mDelNoteDate = oField.ValueAsVariant
            Case (FID_RETURNNOTE_Comm):             mComm = oField.ValueAsVariant
            Case (FID_RETURNNOTE_OrigDocKey):       mOrigDocKey = oField.ValueAsVariant
            Case (FID_RETURNNOTE_EnteredBy):        mEnteredBy = oField.ValueAsVariant
            Case (FID_RETURNNOTE_Comment):          mComment = oField.ValueAsVariant
            Case (FID_RETURNNOTE_SupplierNumber):   mSupplierNumber = oField.ValueAsVariant
            Case (FID_RETURNNOTE_ReturnDate):       mReturnDate = oField.ValueAsVariant
            Case (FID_RETURNNOTE_OrigPONumber):     mOrigPONumber = oField.ValueAsVariant
            Case (FID_RETURNNOTE_SupplierReturnNumber): mSupplierReturnNumber = oField.ValueAsVariant
            Case (FID_RETURNNOTE_InvCrnMatched):    mInvCrnMatched = oField.ValueAsVariant
            Case (FID_RETURNNOTE_InvCrnDate):       mInvCrnDate = oField.ValueAsVariant
            Case (FID_RETURNNOTE_InvCrnNumber):     mInvCrnNumber = oField.ValueAsVariant
            Case (FID_RETURNNOTE_VarianceValue):    mVarianceValue = oField.ValueAsVariant
            Case (FID_RETURNNOTE_InvoiceValue):     mInvoiceValue = oField.ValueAsVariant
            Case (FID_RETURNNOTE_InvoiceVAT):       mInvoiceVAT = oField.ValueAsVariant
            Case (FID_RETURNNOTE_MatchingComment):  mMatchingComment = oField.ValueAsVariant
            Case (FID_RETURNNOTE_MatchingDate):     mMatchingDate = oField.ValueAsVariant
            Case (FID_RETURNNOTE_ReceiptDate):      mReceiptDate = oField.ValueAsVariant
            Case (FID_RETURNNOTE_RestockCharge):    mRestockCharge = oField.ValueAsVariant
            Case (FID_RETURNNOTE_Commit):           mCommit = oField.ValueAsVariant
            Case (FID_RETURNNOTE_CollectionNoteNumber): mCollectionNoteNumber = oField.ValueAsVariant
            Case (FID_RETURNNOTE_OriginalDelNoteDRL):   mOriginalDelNoteDRL = oField.ValueAsVariant
            Case (FID_RETURNNOTE_ShortageNote):
                                                    If oField.ValueAsVariant = SHORTAGES_DOC_CODE Then
                                                        mShortageNote = True
                                                    Else
                                                        mShortageNote = False
                                                    End If
            Case (FID_RETURNNOTE_ReleaseNumber):   mReleaseNumber = oField.ValueAsVariant
            Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow



'##ModelId=3F0E8B7C0356
Private Sub Class_Initialize()
    
    Call DebugMsg(MODULE_NAME, "Initialise", endlTraceIn)
    mDocType = 0
    ReDim mastrUpdatedLines(0)
    
End Sub

'##ModelId=3F0E8B7C03CE
Private Function IBo_CreateNew() As IBo

    Set IBo_CreateNew = New cReturnNote

End Function

'##ModelId=3F0E8B7D0068
Private Property Get IBo_DebugString() As String
    
    IBo_DebugString = "Returns Note - " & mDocNo

End Property

'##ModelId=3F0E8B7D013A
Private Function IBo_GetField(nFid As Long) As IField

    Set IBo_GetField = GetField(nFid)

End Function

'##ModelId=3F0E8B7D0249
Private Function IBo_GetSelectAllRow() As IRowSelector
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

'##ModelId=3F0E8B7D02CB
Private Function Initialise(oSession As ISession) As cReturnNote
    Set m_oSession = oSession
    Set Initialise = Me
End Function
'##ModelId=3F0E8B7D03D9
Private Function IBo_Initialise(oSession As ISession) As IBo
    
    Set IBo_Initialise = Initialise(oSession)

End Function

'##ModelId=3F0E8B7E0100
Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_RETURNNOTE

End Property

'##ModelId=3F0E8B7E01AA
Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

'##ModelId=3F0E8B7E0254
Public Function IBo_Load() As Boolean
    
    IBo_Load = Load

End Function
'##ModelId=3F0E8B7E02AE
Private Function Load() As Boolean
    
Dim oView As IView
    
    Load = False
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.Merge(GetSelectAllRow)
        
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(moRowSel)
    If Not (oView Is Nothing) Then
        If oView.Count >= 1 Then Load = LoadFromRow(oView.Row(1))
    End If

End Function

'##ModelId=3F0E8B7E0330
Private Function ISysBo_LoadFromRow(oRow As IRow) As Boolean
    
    Call LoadFromRow(oRow)

End Function

'##ModelId=3F0E8B7F0057
Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & App.Revision

End Property


'##ModelId=3F0E8B7F013D
Public Function GetField(lFieldID As Long) As IField

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    Select Case (lFieldID)
        Case (FID_RETURNNOTE_DocNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDocNo
        Case (FID_RETURNNOTE_DocType):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDocType
        Case (FID_RETURNNOTE_Value):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValue
        Case (FID_RETURNNOTE_Cost):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mCost
        Case (FID_RETURNNOTE_DelNoteDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDelNoteDate
        Case (FID_RETURNNOTE_Comm):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mComm
        Case (FID_RETURNNOTE_OrigDocKey):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mOrigDocKey
        Case (FID_RETURNNOTE_EnteredBy):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mEnteredBy
        Case (FID_RETURNNOTE_Comment):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mComment
        Case (FID_RETURNNOTE_SupplierNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierNumber
        Case (FID_RETURNNOTE_ReturnDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mReturnDate
        Case (FID_RETURNNOTE_OrigPONumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mOrigPONumber
        Case (FID_RETURNNOTE_SupplierReturnNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierReturnNumber
        Case (FID_RETURNNOTE_InvCrnMatched):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mInvCrnMatched
        Case (FID_RETURNNOTE_InvCrnDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mInvCrnDate
        Case (FID_RETURNNOTE_InvCrnNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mInvCrnNumber
        Case (FID_RETURNNOTE_VarianceValue):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mVarianceValue
        Case (FID_RETURNNOTE_InvoiceValue):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mInvoiceValue
        Case (FID_RETURNNOTE_InvoiceVAT):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mInvoiceVAT
        Case (FID_RETURNNOTE_MatchingComment):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mMatchingComment
        Case (FID_RETURNNOTE_MatchingDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mMatchingDate
        Case (FID_RETURNNOTE_ReceiptDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mReceiptDate
        Case (FID_RETURNNOTE_RestockCharge):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mRestockCharge
        Case (FID_RETURNNOTE_Commit):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCommit
        Case (FID_RETURNNOTE_CollectionNoteNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCollectionNoteNumber
        Case (FID_RETURNNOTE_OriginalDelNoteDRL):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mOriginalDelNoteDRL
        Case (FID_RETURNNOTE_SecondarySupplierNumber): 'Fudge for UpTrac compatibility
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierNumber
        Case (FID_RETURNNOTE_ShortageNote):
                Set GetField = New CFieldString
                If mShortageNote = True Then
                    GetField.ValueAsVariant = SHORTAGES_DOC_CODE
                Else
                    GetField.ValueAsVariant = vbNullString
                End If
        Case (FID_RETURNNOTE_ReleaseNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mReleaseNumber
    End Select
    
    If Not GetField Is Nothing Then GetField.ID = lFieldID

End Function

'##ModelId=3F0E8B7F0256
Private Function GetSelectAllRow() As IRowSelector
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_RETURNNOTE, FID_RETURNNOTE_END_OF_STATIC, m_oSession)

End Function

'##ModelId=3F0E8B7F02E2
Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

'##ModelId=3F0E8B7F033C
Public Function IBo_SaveIfNew() As Boolean

    IBo_SaveIfNew = Save(SaveTypeIfNew)

End Function

'##ModelId=3F0E8B7F0396
Public Function IBo_SaveIfExists() As Boolean

    IBo_SaveIfExists = Save(SaveTypeIfExists)

End Function

'##ModelId=3F0E8B800008
Public Function IBo_Delete() As Boolean

    IBo_Delete = Save(SaveTypeDelete)

End Function

'##ModelId=3F0E8B800062
Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function


'##ModelId=3F0E8B8000BC
Private Function Save(eSave As enSaveType) As Boolean
' Save all properties to the database
Dim lLineNo       As Long
Dim oRetLine      As cReturnNoteLine
Dim oSysNum       As cSystemNumbers
Dim oRetHdr       As cReturnHeader
Dim oSuppRetLine  As cReturnLine
Dim oNarr         As Object
    
    Save = False
    mDocType = 3
    
    If LenB(mComm) = 0 Then mComm = "0000"
    If LenB(mReleaseNumber) = 0 Then mReleaseNumber = "00"
    
    If IsValid() Then
        If eSave = SaveTypeIfNew Then
            'Get Next DRL Number
            Set oSysNum = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMNO)
            mDocNo = oSysNum.GetNewReceiptNumber
            Set oSysNum = Nothing
            'Create Supplier Returns tracking header
            Set oRetHdr = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNHDR)
'            oRetHdr.SupplierReturnNo = mSupplierReturnNumber
            oRetHdr.SupplierNo = mSupplierNumber
            oRetHdr.DateCreated = mDelNoteDate
            oRetHdr.CollectionDate = mDelNoteDate
            oRetHdr.PurchaseOrderNo = mOrigPONumber
            oRetHdr.DRLNo = mDocNo
            oRetHdr.ReturnValue = mValue
            oRetHdr.Printed = Printed
            Call oRetHdr.IBo_SaveIfNew
            'associate Return Header to print to Returns control file
            mOrigDocKey = oRetHdr.ReturnID
            mSupplierReturnNumber = oRetHdr.SupplierReturnNo
            If LenB(mNarrative) <> 0 Then 'if narrative captured then call sub BO to save
                Set oNarr = m_oSession.Database.CreateBusinessObject(CLASSID_DELNOTENARRATIVE)
                oNarr.DocumentNumber = mDocNo
                If InStr(mNarrative, vbCrLf) > 0 Then
                    If InStr(mNarrative, vbCrLf) > 1 Then
                        oNarr.NarrativeText1 = Left$(mNarrative, InStr(mNarrative, vbCrLf) - 1)
                    End If
                    oNarr.NarrativeText2 = Mid$(mNarrative, InStr(mNarrative, vbCrLf) + 2)
                Else
                    oNarr.NarrativeText1 = Left$(mNarrative, 40)
                    oNarr.NarrativeText2 = Mid$(mNarrative, 41)
                End If
                oNarr.StoreNumber = m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
                oNarr.PartCode = "000000"
                oNarr.SequenceNumber = "0000"
                Call oNarr.IBo_SaveIfNew
                Set oNarr = Nothing
            End If
        Else
            mReleaseNumber = Format$(Val(mReleaseNumber) + 1, "00")
            'Update tracking return header
            Set oRetHdr = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNHDR)
            Call oRetHdr.IBo_AddLoadFilter(CMP_EQUAL, FID_RETURNHDR_SupplierReturnNo, mSupplierReturnNumber)
            oRetHdr.GetLines = True
            Call oRetHdr.IBo_LoadMatches
            oRetHdr.ReturnValue = mValue
            If oRetHdr.Lines.Count = 0 Then
            End If
            'First save all edited line to the database
            For lLineNo = 1 To UBound(mastrUpdatedLines) Step 1
                Set oRetLine = mcolLines(CLng(mastrUpdatedLines(lLineNo)))
                Call oRetLine.IBo_SaveIfExists
                Call oRetHdr.UpdateItemQuantity(oRetLine.LineNo, oRetLine.PartCode, oRetLine.ReturnQty, oRetLine.ReturnReasonCode, oRetLine.Narrative)
            Next lLineNo
            'Step through list of lines and if none have the a line no then Save as new
            For lLineNo = 1 To mcolLines.Count Step 1
                Set oRetLine = mcolLines(CLng(lLineNo))
                If LenB(oRetLine.RetNoteKey) = 0 Then
                    oRetLine.RetNoteKey = Me.DocNo
                    Call oRetLine.IBo_SaveIfNew
                    Call CreateReturnLine(oRetHdr.ReturnID, oRetLine)
                 End If
            Next lLineNo
            Call oRetHdr.IBo_SaveIfExists
            'Save narrative for returns note if edited
            If mintNarrStatus = EDITED Then
                Set oNarr = m_oSession.Database.CreateBusinessObject(CLASSID_DELNOTENARRATIVE)
                oNarr.DocumentNumber = mDocNo
                If InStr(mNarrative, vbCrLf) > 0 Then
                    If InStr(mNarrative, vbCrLf) > 1 Then
                        oNarr.NarrativeText1 = Left$(mNarrative, InStr(mNarrative, vbCrLf) - 1)
                    End If
                    oNarr.NarrativeText2 = Mid$(mNarrative, InStr(mNarrative, vbCrLf) + 2)
                Else
                    oNarr.NarrativeText1 = Left$(mNarrative, 40)
                    oNarr.NarrativeText2 = Mid$(mNarrative, 41)
                End If
                oNarr.StoreNumber = m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
                oNarr.PartCode = "000000"
                oNarr.SequenceNumber = "0000"
                Call oNarr.IBo_SaveIfExists
                Set oNarr = Nothing
            End If
        End If
           
        Save = m_oSession.Database.SaveBo(eSave, Me)
        
        'Save each line for the Supplier Returns Note
        If eSave = SaveTypeIfNew Then
            For lLineNo = 1 To mcolLines.Count Step 1
                Set oRetLine = mcolLines(CLng(lLineNo))
                oRetLine.RetNoteKey = Me.DocNo
                Call oRetLine.IBo_SaveIfNew
                'Create Supplier Return tracking line
                Call CreateReturnLine(oRetHdr.ReturnID, oRetLine)
            Next lLineNo
        End If
    End If

End Function
Private Sub CreateReturnLine(lngReturnID As Long, oRetLine As cReturnNoteLine)

Dim oSuppRetLine  As cReturnLine

    'Create Supplier Return tracking line
    Set oSuppRetLine = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNLINE)
    oSuppRetLine.ReturnID = lngReturnID
    oSuppRetLine.LineNo = oRetLine.LineNo
    oSuppRetLine.PartCode = oRetLine.PartCode
    oSuppRetLine.PartAlphaKey = oRetLine.PartCodeAlphaCode
    oSuppRetLine.QuantityReturned = oRetLine.ReturnQty
    oSuppRetLine.Price = oRetLine.OrderPrice
    oSuppRetLine.Cost = oRetLine.CurrentCost
    oSuppRetLine.ReturnCode = Val(oRetLine.ReturnReasonCode)
    oSuppRetLine.ReturnReason = oRetLine.Narrative
    Call oSuppRetLine.IBo_SaveIfNew

End Sub
'##ModelId=3F0E8B8001E9
Private Function Delete() As Boolean
    Debug.Assert False
End Function

'##ModelId=3F0E8B80026B
Private Function IsValid() As Boolean
'    Debug.Assert False
    IsValid = True
End Function


'##ModelId=3F0E8B8002F7
Private Function GetAllFieldsAsRow() As IRow
' Returns a CRow object containing one field object for each property.
    
Dim oRow As IRow
Dim nFid    As Long
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    For nFid = (CLASSID_RETURNNOTE * &H10000) + 1 To FID_RETURNNOTE_END_OF_STATIC Step 1
        oRow.Add GetField(nFid)
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function

'<CACH>*************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'******************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection
'*              criteria before calling the IBo_Load method.  This appends the
'*              selection criteria to the oRowSel object which is used by the
'*              IBo_Load method.
'******************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare
'against
'*In/Out:Value  Variant. - Value that Field will be compared to
'******************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'******************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***********************************************************************
'##ModelId=3F0E8B800379
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".IBo_AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    If FieldID = FID_RETURNNOTE_ShortageNote Then
        If Value = True Then
            oField.ValueAsVariant = SHORTAGES_DOC_CODE
        Else
            oField.ValueAsVariant = vbNullString
        End If
    Else
        oField.ValueAsVariant = Value
    End If
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.AddSelection(Comparator, oField)
    IBo_AddLoadFilter = True

End Function 'IBo_AddLoadFilter



'<CACH>*************************************************************************-
'***************
'* Function:  Boolean IBo_AddLoadField()
'******************************************************************************-
'****************
'* Description: Part of the IBo Interface.  Used to set-up all fields that
'must be returned
'*              when using the LoadMatches method.  This appends the field to
'the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is
'populated.
'******************************************************************************-
'****************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare
'against
'******************************************************************************-
'****************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***********************************************************************-
'****************
'##ModelId=3F0E8B8101C2
Public Sub IBo_AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".IBo_AddLoadField"
    
    'Add field to Row selector
    If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'IBo_AddLoadField

'##ModelId=3F0E8B8102B3
Public Sub IBo_ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

'##ModelId=3F0E8B810303
Public Sub IBo_ClearLoadField()

    Set moLoadRow = Nothing

End Sub

'##ModelId=3F0E8B810353
Public Function IBo_LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection

' Load up all properties from the database
Dim oView As IView
Dim colBO       As Collection
Dim oBO         As ISysBo
Dim lBONo       As Long
Dim oLoadFields As IRowSelector
Dim oField As IField
    
    Set colBO = New Collection
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = m_oSession.Root.CreateUtilityObject("CRowSelector")
    
    'Add in default Document type filter
    Set oField = GetField(FID_RETURNNOTE_DocType)
    oField.ValueAsVariant = DOCTYPE_SUPPRET
    Call oLoadFields.AddSelection(CMP_EQUAL, oField)
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.CreateBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            Call colBO.Add(oBO)
            If lBONo = 1 Then Call LoadFromRow(oView.Row(1))
        Next lBONo
    End If
    
    Set IBo_LoadMatches = colBO

End Function


'##ModelId=3F0E8B82005B
Private Function IBo_Interface(Optional eInterfaceType As Long) As IBo
    Set IBo_Interface = Interface(eInterfaceType)
End Function

'##ModelId=3F0E8B820188
Public Function Interface(Optional eInterfaceType As Long) As cReturnNote
    Select Case (eInterfaceType)
    Case BO_INTERFACE_IBO:
        Dim oBO As IBo
        Set oBO = Me
        Set Interface = oBO
    Case Else:
        Set Interface = Me
    End Select
End Function


'##ModelId=3F0E8B820282
Public Function IBo_GetAllFieldsAsRow() As IRow
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

'##ModelId=3F0E8B8202E6
Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_RETURNNOTE_END_OF_STATIC

End Function


'##ModelId=3F0E8B820340
Public Function CreateFile()

Const PROCEDURE_NAME = MODULE_NAME & ".CreateFile"

Const EDI_NA As String = vbNullString

Dim oRowSel     As IRowSelector
Dim oField      As IField
Dim strHeader   As String
Dim strTrailer  As String
Dim lngLineNo   As Long
Dim lngNoLines  As Long
Dim strLine     As String
Dim tsOrder     As TextStream
Dim strFilename As String
Dim dteNA       As Date
Dim oFileNo     As cEDIFileControl
Dim oLine       As cReturnNoteLine
Dim strSeqNo    As String

On Error GoTo Bad_CreateFile

    'Create field for storing Key into
    Set oField = GetField(FID_RETURNNOTE_DocNo)
    If oField Is Nothing Then Exit Function
    
    'Add field to Row selector
    Set oRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call oRowSel.AddSelection(CMP_EQUAL, oField)
    
    If LenB(mstrDateFmt) = 0 Then mstrDateFmt = UCase$(m_oSession.GetParameter(PRM_EDI_DATE_FMT))
    
    strFilename = m_oSession.GetParameter(PRM_TXOUT_BACKUP_FOLDER)
    If (Right$(strFilename, 1) <> "\") Then strFilename = strFilename & "\"
       
    Set oFileNo = m_oSession.Database.CreateBusinessObject(CLASSID_EDIFILECONTROL)
    
    'reset Narrative lines count, dependant on if DRL has notes for it
    If LenB(mNarrative) <> 0 Then
        lngNoLines = 1
    Else
        lngNoLines = 0
    End If
    
    lngNoLines = lngNoLines + Lines.Count + 1
    'Count the number of Narrative lines to add into the Header Record
    For lngLineNo = 1 To Lines.Count Step 1
        If (LenB(mcolLines(CLng(lngLineNo)).Narrative) <> 0) Then lngNoLines = lngNoLines + 1
    Next lngLineNo
    
'    strHeader = "HR" & Format$(Now(), "DD/MM/YY HH:NN:SS") & " " & oFileNo.LastSequenceNo & " " & Format$(lngNoLines, "000000") & " " & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
'GetEDITextStream(ByRef blnStoreToHeadOffice As Boolean, ByRef strShortCode As String, ByRef strFilePath As String, ByVal strSequenceNo As String) As TextStream
    Set tsOrder = oFileNo.GetEDITextStream(True, RET_NOTE_FILECODE, strFilename, strSeqNo)
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "DRL SUM OUT File=" & strSeqNo)
    
    strHeader = "HR" & Format$(Now(), "DD/MM/YY HH:NN:SS") & " " & strSeqNo & " " & Format$(lngNoLines, "000000") & " " & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
        
    Call tsOrder.WriteLine(strHeader)

'    Call tsOrder.WriteLine("DS," & m_oSession.Database.GetLiteralView(oRowSel, 2, vbCrLf, ",", vbNullString))
    tsOrder.Write "DS," & mDocNo & "," & mDocType & "," & mValue & "," & mCost & "," & FormatEDIDate(mDelNoteDate) & ","
'   ds:numb,ds:type,ds:valu,ds:cost,ds:date
    tsOrder.Write mOrigDocKey & "," & mEnteredBy & "," & mComment & "," & mSupplierNumber & ","
'   ds:tkey,ds:init,ds:info,e ds:0sup wsup,wsup
    tsOrder.Write mConsignmentRef & "," & mPONumber & "," & FormatEDIDate(mPODate) & "," & mReleaseNumber & ","
'   ds:0con,ds:0pon,ds:0dat,ds:0rel
    tsOrder.Write mSOQControlNumber & ","
'   ds:0soq
    For lngLineNo = 1 To 9 Step 1
        tsOrder.Write ","
    Next lngLineNo
'   ds:0dl1,ds:0dl2,ds:0dl3,ds:0dl4,ds:0dl5,ds:0dl6,ds:0dl7,ds:0dl8,ds:0dl9
    tsOrder.Write mSource & "," & mStoreNo & ",000,"
'   ds:0src,ds:1str,ds:1ibt
    If mPrinted = True Then
        tsOrder.Write "Y"
    Else
        tsOrder.Write "N"
    End If
    tsOrder.Write "," & mConsignmentKey & "," & mSupplierNumber & "," & FormatEDIDate(dteNA) & "," & mOrigPONumber & ","
'   ds:1prt,ds:1con,  e   ds:3sup   wsup,,wsup,ds:3dat,ds:3pon,ds:3ret
    tsOrder.Write mSupplierReturnNumber & "," & mInvCrnMatched & "," & FormatEDIDate(mInvCrnDate) & "," & mInvCrnNumber & "," & mVarianceValue & ","
'   ds:matf,ds:idat,ds:invn,rvrv
    tsOrder.Write mInvoiceValue & "," & mInvoiceVAT & "," & mMatchingComment & "," & FormatEDIDate(mMatchingDate) & "," & FormatEDIDate(mReceiptDate) & ","
'   ds:ival,ds:ivat,memo,ds:mdat,ds:tdat
    tsOrder.WriteLine mRestockCharge & "," & mCommit
'   ds:carval,canc-ist?

    
    For lngLineNo = 1 To Lines.Count Step 1
        Set oLine = mcolLines(CLng(lngLineNo))
        
        tsOrder.Write "DD," & oLine.RetNoteKey & "," & oLine.LineNo & "," & oLine.PartCode & "," & oLine.PartCodeAlphaCode
'dd:numb,dd:seqn,dd:skun,dd:alph
        tsOrder.Write "," & oLine.OrderQty & "," & oLine.ReturnQty & "," & oLine.OrderPrice & "," & oLine.BlanketDiscDesc
'dd:ordq'dd:recq'dd:ordp'dd:bdes
        tsOrder.Write "," & oLine.BlanketPartCode & "," & oLine.CurrentPrice & "," & oLine.CurrentCost & "," & oLine.IBTQuantity
'dd:bspc'dd:pric'dd:Cost'dd:ibtq
        tsOrder.Write "," & oLine.ReturnQty & "," & oLine.ToFollowQty & "," & oLine.ReturnReasonCode & "," & oLine.POLineNumber & ","
'dd:retq,'dd:folq'dd:reas'dd:poln
        If oLine.Checked = True Then
            tsOrder.Write "Y"
        Else
            tsOrder.Write "N"
        End If
'dd:ichk
        tsOrder.WriteLine "," & oLine.SinglesSellingUnit
'dd:qpsu

    Next lngLineNo
    
    If LenB(mNarrative) <> 0 Then
        tsOrder.Write "DN" & "," & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
        tsOrder.WriteLine "," & mDocNo & ",0000,000000," & Replace(mNarrative, vbCrLf, vbNullString)
    End If
    
    For lngLineNo = 1 To Lines.Count Step 1
        Set oLine = mcolLines(CLng(lngLineNo))
        If LenB(oLine.Narrative) <> 0 Then
            tsOrder.Write "DN" & "," & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber & ","
            tsOrder.WriteLine oLine.RetNoteKey & "," & oLine.LineNo & "," & oLine.PartCode & "," & Replace(oLine.Narrative, vbCrLf, vbNullString)
        End If
    Next lngLineNo
    
    strTrailer = "TR (V" & IBo_Version & ")"
    Call tsOrder.WriteLine(strTrailer)
    
    Call tsOrder.Close
        
    Call UpdateCommNumber(mDocNo, strSeqNo)
    
    Call oFileNo.MarkAsDone(True, "RC", strSeqNo, vbNullString, lngNoLines)
    
    CreateFile = True
    
    Exit Function
    
Bad_CreateFile:

    CreateFile = False
    Call Err.Raise(Err.Number, Err.Source, Err.Description)
    
End Function


'##ModelId=3F0E8B8203A4
Public Function UpdateCommNumber(strRetNoteKey As String, strCommNumber As String) As String

Dim oRow    As IRow
Dim oGField As CFieldGroup

    If strRetNoteKey <> mDocNo Then
        Call IBo_ClearLoadFilter
        Call IBo_AddLoadFilter(CMP_EQUAL, FID_RETURNNOTE_DocNo, strRetNoteKey)
        Call IBo_AddLoadField(FID_RETURNNOTE_DocNo)
        Call IBo_AddLoadField(FID_RETURNNOTE_Comm)
        Call IBo_LoadMatches
    End If
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_RETURNNOTE_DocNo))
    
    Set oGField = GetField(FID_RETURNNOTE_Comm)
    ' and add to the row
    Call oRow.Add(oGField)
    
    mComm = strCommNumber
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)

End Function

'##ModelId=3F0E8B830161
Public Function DeleteItem(strLineNo As String, strPartCode As String) As Boolean

Dim lngItemNo As Long
Dim oLine     As cReturnNoteLine

    DeleteItem = False
    If mcolLines Is Nothing Then Exit Function
    'Find selected line in collection of lines
    Let strLineNo = Format$(Val(strLineNo), "0000")
    For lngItemNo = 1 To mcolLines.Count Step 1
        If (mcolLines(lngItemNo).LineNo = strLineNo) And (mcolLines(lngItemNo).PartCode = strPartCode) Then
            Set oLine = mcolLines(lngItemNo)
            Exit For
        End If
    Next lngItemNo
    'check that line was found
    If oLine Is Nothing Then Exit Function
    'add updated line to list of lines to be updated to database
    ReDim Preserve mastrUpdatedLines(UBound(mastrUpdatedLines) + 1)
    lngItemNo = UBound(mastrUpdatedLines)
    mastrUpdatedLines(lngItemNo) = strLineNo
    'set quantity received to 0 to reverse out delivery
    oLine.ReturnedQty = 0
    oLine.ReturnQty = 0
    oLine.Narrative = vbNullString
    DeleteItem = True
    
End Function

'##ModelId=3F0E8B830310
Public Function UpdateItemQuantity(strLineNo As String, strPartCode As String, dblQuantity As Double, strReasonCode As String, strComment As String) As Boolean

Dim lngItemNo As Long
Dim oLine     As cReturnNoteLine

    UpdateItemQuantity = False
    If mcolLines Is Nothing Then Exit Function
    'Find selected line in collection of lines
    Let strLineNo = Format$(Val(strLineNo), "0000")
    For lngItemNo = 1 To mcolLines.Count Step 1
        If (mcolLines(lngItemNo).LineNo = strLineNo) And (mcolLines(lngItemNo).PartCode = strPartCode) Then
            Set oLine = mcolLines(lngItemNo)
            Exit For
        End If
    Next lngItemNo
    'check that line was found
    If oLine Is Nothing Then Exit Function
    'add updated line to list of lines to be updated to database
    ReDim Preserve mastrUpdatedLines(UBound(mastrUpdatedLines) + 1)
    lngItemNo = UBound(mastrUpdatedLines)
    mastrUpdatedLines(lngItemNo) = strLineNo
    'set quantity received to 0 to reverse out delivery
    oLine.ReturnQty = dblQuantity
    oLine.ReturnedQty = dblQuantity
    oLine.ReturnReasonCode = strReasonCode
    oLine.Narrative = strComment
    UpdateItemQuantity = True
    
End Function


